;(function($, window, undefined){

	
	var canvas = document.getElementById('canvas'),
		context = canvas.getContext('2d'),
		canvasWidth = canvas.width,
		canvasHeight = canvas.height
	
	canvas2 = document.getElementById('canvas2'),
	context2 = canvas2.getContext('2d'),
	canvasWidth2 = canvas2.width,
		canvasHeight2 = canvas2.height,
			
		
		
		
		
		
	
		
		
		
		
	
		s = Sound('./WebAudioAPI/sound/preview.mp3'),
		peaks = [];
	s.loop(true);
	s.on('fxLoaded', function(){
		s.play();
	});
	$('#volume').val(70);
	$('#fx').val(0);
	$('#fx2').val(0);
	s.volume(0.7);
	s.fxVolume(0);
	s.fx2Volume(0);
	s.convolution('./WebAudioAPI/sound/CUSTOM_gen concert.WAV');
	s.delay('./WebAudioAPI/sound/INSTR rock plate.WAV');
	s.on('load', function(){
		$('#loading').add('#progress').fadeOut(500, function(){
			$(canvas).add('#volume, #fx, #fx2, #description').css('display', 'block');
		});
	});
	s.on('audioprocess', function(input){
		var gain = s.volume(),
			bars = input.length,
			spacing = 10,
			width = 8,
			now = Date.now();
		context.clearRect(0, 0, canvasWidth, canvasHeight);
		context.fillStyle = '#bada55';
		for ( var i = 0; i < bars; i++ ){
			var magnitude = input[i] * gain,
				lingrad = context.createLinearGradient(0, 0, 0, canvasHeight),
				peak = [i * spacing, canvasHeight - magnitude, width, 4, now];
			if ( peaks.length != bars || now - peaks[i][4] > 1000){
				peaks[i] = peak;
			}
			if ( peaks.length && canvasHeight - magnitude < peaks[i][1] ){
				peaks[i][1] = canvasHeight - magnitude;
				peaks[i][4] = now;
			}
	        lingrad.addColorStop(0, '#bada55');
	        lingrad.addColorStop(1, '#bada55');
	        context.fillStyle = lingrad;
	        context.fillRect(i * spacing, canvasHeight, width, -magnitude);
		}
		for ( var i = 0, l = peaks.length; i < l; i++ ){
			var lingrad = context.createLinearGradient(0, 0, 0, canvasHeight);
			lingrad.addColorStop(0, '#bada55');
	        lingrad.addColorStop(1, '#bada55');
			context.fillStyle = lingrad;
	        context.fillRect.apply(context, peaks[i]);
		}
	});
	
	
	s.on('audioprocess', function() {

var pointsL = [];

return function() {
    quality(0.1);

    decay(0.5);

    for (var i=0;i<128;i++)
      pointsL[i] = [ 1/127*i, 0.5 + 2 * 0.2 ];

    var h = ((time * 10) % 360) >> 0;

    context2.drawPath(pointsL, false, null, "hsl(" + h + ",100%,15%)", 28);
    context2.drawPath(pointsL, false, null, "hsl(" + h + ",100%,25%)", 20);

    quality(0.75, true);

    context2.drawPath(pointsL, false, null, "white", 2);

    commit();

};

});

	
	
	
	
	
	
	
	
	
	s.on('progress', function(loaded, total){
		var progress = loaded / total,
			txt = progress > .99 ? 'Decoding...' : Math.round( progress * 100 ) + '%';
		$('#progress').text( txt );
	});
	
	var paused = false;
	$('#pause').click(function() {
		if(paused){
			s.play()
			paused =false;
			$(this).html("Pause");
		}
		else{
			s.pause();
			paused = true;
			$(this).html("Play");
		}

	});
	
	
	
	
	
	
	$('#volume').change(function(){
		var val = parseInt( $(this).val() ) / 100;
		s.volume(val);
	});
	$('#fx').change(function(){
		var val = parseInt( $(this).val() ) / 100;
		s.fxVolume(val);
	});
	$('#fx2').change(function(){
		var val = parseInt( $(this).val() ) / 100;
		s.fxVolume(val);
	});
	
	window.s = s;
}(jQuery, window));
